<?php
/*
  $Id: cc_validation.php,v 1.3 2003/02/12 20:43:41 hpdl Exp $

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2003 osCommerce

  Released under the GNU General Public License
*/

class ach_validation {

	var $bank_aba, $bank_account, $bank_account_confirm, $error;
	
	function ach_validation($bank_aba, $bank_account, $bank_account_confirm) {
	
		$this->bank_aba = $bank_aba;
		$this->bank_account = $bank_account; 
		$this->bank_account_confirm = $bank_account_confirm;
	
	}
	
	function validate() {
		if ( !$this->aba_validate($this->bank_aba) ) {
			$this->error = 'Invalid Bank Routing # given.';
			return false;
		}
		
		if ( !is_numeric($this->bank_account) ) {
			$this->error = 'Invalid Bank Account # given.';
			return false;
		} else if ( $this->bank_account != $this->bank_account_confirm ) {
			$this->error = 'Bank Accounts given do not match.';
			return false;
		}
		
		return true;
	}
	
	// CHECK FOR VALID ABA NUMBER
	function aba_validate($aba) { 
	  	
		// First, check for 9 digits and non-numeric characters. 
	 	if (ereg("^[0-9]{9}$",$aba)) { 
			$n = 0; 
			
			for ($i = 0; $i < 9; $i += 3) { 
		  		$n += (substr($aba,$i,1) * 3) 
				+ (substr($aba,$i + 1,1) * 7) 
				+ (substr($aba,$i + 2,1)); 
			} 
	
			// If the resulting sum is an even multiple of ten (but not zero), 
			// the aba routing number is good. 
			if ($n != 0 && $n % 10 == 0) { 
		  		return(true); // found good aba 
			} 
			else { 
		  		return(false); 
			} 
	
	  	} 
	  	else { 
			return(false); 
	  	} 
	
	} 


}
?>