<?php
/*
  $Id: $

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2007 osCommerce

  Released under the GNU General Public License
*/

  class gotobilling_ach {
    var $code, $title, $description, $enabled;

// class constructor
    function gotobilling_ach() {
      global $order;

      $this->code = 'gotobilling_ach';
      $this->title = MODULE_PAYMENT_GOTOBILLING_TEXT_TITLE;
      $this->public_title = MODULE_PAYMENT_GOTOBILLING_TEXT_PUBLIC_TITLE;
      $this->description = MODULE_PAYMENT_GOTOBILLING_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_GOTOBILLING_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_GOTOBILLING_STATUS == 'True') ? true : false);

      if ((int)MODULE_PAYMENT_GOTOBILLING_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_GOTOBILLING_ORDER_STATUS_ID;
      }

      if (is_object($order)) $this->update_status();

      //$this->form_action_url = 'https://GOTOBILLING.de/merchant/' . MODULE_PAYMENT_GOTOBILLING_ID . '/processor.php';
	  
	  $this->form_action_url = 'https://secure.gotobilling.com/os/system/gateway/transact.php';
    }

	// class methods
    function update_status() {
      global $order;

      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_GOTOBILLING_ZONE > 0) ) {
        $check_flag = false;
        $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_GOTOBILLING_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
        while ($check = tep_db_fetch_array($check_query)) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->billing['zone_id']) {
            $check_flag = true;
            break;
          }
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }

    function javascript_validation() {
      return false;
    }

    function selection() {
      global $order;

      for ($i=1; $i<13; $i++) {
        $expires_month[] = array('id' => sprintf('%02d', $i), 'text' => strftime('%B',mktime(0,0,0,$i,1,2000)));
      }

      $today = getdate(); 
      for ($i=$today['year']; $i < $today['year']+10; $i++) {
        $expires_year[] = array('id' => strftime('%y',mktime(0,0,0,1,1,$i)), 'text' => strftime('%Y',mktime(0,0,0,1,1,$i)));
      }
      $selection = array('id' => $this->code,
                         'module' => $this->title,
                         'fields' => array(array('title' => MODULE_PAYMENT_GOTOBILLING_TEXT_BANK_NAME,
                                                 'field' => tep_draw_input_field('gotobilling_bank_name')),
                                           array('title' => MODULE_PAYMENT_GOTOBILLING_TEXT_BANK_ROUTING,
                                                 'field' => tep_draw_input_field('gotobilling_bank_routing')),
                                           array('title' => MODULE_PAYMENT_GOTOBILLING_TEXT_BANK_ACCOUNT,
                                                 'field' => tep_draw_input_field('gotobilling_bank_account')),
										   array('title' => MODULE_PAYMENT_GOTOBILLING_TEXT_BANK_ACCOUNT_CONFIRM,
                                                 'field' => tep_draw_input_field('gotobilling_confirm_account')),
									 )
					);

      return $selection;
    }

    function pre_confirmation_check() {
       global $HTTP_POST_VARS;
	   
	   include(DIR_WS_CLASSES . 'ach_validation.php');

      $ach_validation = new ach_validation($HTTP_POST_VARS['gotobilling_bank_routing'],$HTTP_POST_VARS['gotobilling_bank_account'],$HTTP_POST_VARS['gotobilling_confirm_account']);

	  if ( !$ach_validation->validate() ) {
        $payment_error_return = 'payment_error=' . $this->code . 'error=' . urlencode($ach_validation->error) . '&gotobilling_bank_routing=' . urlencode($HTTP_POST_VARS['gotobilling_bank_routing']) . '&gotobilling_bank_account=' . $HTTP_POST_VARS['gotobilling_bank_account'] . '&gotobilling_bank_account_confirm=' . $HTTP_POST_VARS['gotobilling_bank_account_confirm'];

        tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
      }

      $this->bank_name = $HTTP_POST_VARS['gotobilling_bank_name'];
      $this->bank_routing = $HTTP_POST_VARS['gotobilling_bank_routing'];
      $this->bank_account = $HTTP_POST_VARS['gotobilling_bank_account'];
    }

    function confirmation() {
      global $HTTP_POST_VARS;

      $confirmation = array('title' => $this->title . ': ' . 'Info',
                            'fields' => array(array('title' => MODULE_PAYMENT_GOTOBILLING_TEXT_BANK_NAME,
                                                    'field' => $this->bank_name),
                                              array('title' => MODULE_PAYMENT_GOTOBILLING_TEXT_BANK_ROUTING,
                                                    'field' => $this->bank_routing),
                                              array('title' => MODULE_PAYMENT_GOTOBILLING_TEXT_BANK_ACCOUNT,
                                                    'field' => str_repeat('X', (strlen($this->bank_account) - 4)) . substr($this->bank_account, -4))
										)
					);

      return $confirmation;
    }

    function process_button() {
      global $order, $currencies, $currency;

      $zone_code = '';

      if (is_numeric($order->billing['zone_id']) && ($order->billing['zone_id'] > 0)) {
        $zone_query = tep_db_query("select zone_code from " . TABLE_ZONES . " where zone_id = '" . (int)$order->billing['zone_id'] . "'");
        if (tep_db_num_rows($zone_query)) {
          $zone = tep_db_fetch_array($zone_query);

          $zone_code = $zone['zone_code'];
        }
      }

      $process_button_string = tep_draw_hidden_field('merchant_id', MODULE_PAYMENT_GOTOBILLING_MID) .
                               tep_draw_hidden_field('merchant_pin', MODULE_PAYMENT_GOTOBILLING_PIN) .
                               tep_draw_hidden_field('x_debug', MODULE_PAYMENT_GOTOBILLING_DEBUG_MODE) .
							   tep_draw_hidden_field('x_invoice_id', rand(1,999999999)) .
							   tep_draw_hidden_field('ip_address', tep_get_ip_address()) .
                               tep_draw_hidden_field('x_amount', number_format($order->info['total'] * 100, 0, '','')) .
                               tep_draw_hidden_field('x_transaction_type', 'DH') .
							   tep_draw_hidden_field('x_ach_payment_type', 'WEB') .
                               tep_draw_hidden_field('x_customer_id', $order->customer['lastname'].'-'.substr($this->bank_account,-5)) .
							   tep_draw_hidden_field('x_company', $order->customer['company']) .
							   tep_draw_hidden_field('x_first_name', $order->customer['firstname']) .
							   tep_draw_hidden_field('x_last_name', $order->customer['lastname']) .
							   tep_draw_hidden_field('x_email', $order->customer['email_address']) .
                               tep_draw_hidden_field('x_address1', $order->billing['street_address']) .
                               tep_draw_hidden_field('x_city', $order->billing['city']) .
                               tep_draw_hidden_field('x_zip', $order->billing['postcode']) .
                               tep_draw_hidden_field('x_state', $zone_code) .
                               //tep_draw_hidden_field('x_phone', $order->customer['telephone']) .
                               
							   tep_draw_hidden_field('x_ach_account_type', 'PC') .
							   tep_draw_hidden_field('x_ach_route', $this->bank_routing) .
                               tep_draw_hidden_field('x_ach_account', $this->bank_account) .
							   
							   tep_draw_hidden_field('x_relay_url', tep_href_link(FILENAME_CHECKOUT_PROCESS, '', 'SSL', false)) .
                               tep_draw_hidden_field('x_relay_type', 'ACTIVE');
							   
      return $process_button_string;
    }

    function before_process() {
      global $HTTP_GET_VARS;
		
      if ($_GET['status'] == 'G' || $_GET['status'] == 'R') return;
      if ($_GET['status'] == 'D') {
        tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, 'error_message=' . urlencode(MODULE_PAYMENT_GOTOBILLING_TEXT_DECLINED_MESSAGE), 'SSL', true, false));
      }
      // Code 3 is an error - but anything else is an error too (IMHO)
      tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, 'error_message=' . urlencode(MODULE_PAYMENT_GOTOBILLING_TEXT_DECLINED_MESSAGE), 'SSL', true, false));
    }

    function after_process() {
      return false;
    }

    function get_error() {
      global $HTTP_GET_VARS;

      $error = array('title' => GOTOBILLING_ERROR_HEADING,
                     'error' => ((isset($HTTP_GET_VARS['error'])) ? stripslashes(urldecode($HTTP_GET_VARS['error'])) : GOTOBILLING_ERROR_MESSAGE));

      return $error;
    }

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_GOTOBILLING_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable GOTOBILLING Module', 'MODULE_PAYMENT_GOTOBILLING_STATUS', 'True', 'Do you want to accept GOTOBILLING payments?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Merchant ID', 'MODULE_PAYMENT_GOTOBILLING_MID', '', 'The merchant ID for the GOTOBILLING service', '6', '3', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Merchant PIN', 'MODULE_PAYMENT_GOTOBILLING_PIN', '0', 'The merchant pin for the GOTOBILLING service', '6', '4', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Debug Mode', 'MODULE_PAYMENT_GOTOBILLING_DEBUG_MODE', '1', '1 for Testing, 0 for Production', '6', '4', now())");
	  tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_GOTOBILLING_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Payment Zone', 'MODULE_PAYMENT_GOTOBILLING_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.', '6', '2', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Order Status', 'MODULE_PAYMENT_GOTOBILLING_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_PAYMENT_GOTOBILLING_STATUS', 'MODULE_PAYMENT_GOTOBILLING_MID', 'MODULE_PAYMENT_GOTOBILLING_PIN', 'MODULE_PAYMENT_GOTOBILLING_DEBUG_MODE', 'MODULE_PAYMENT_GOTOBILLING_ZONE', 'MODULE_PAYMENT_GOTOBILLING_ORDER_STATUS_ID', 'MODULE_PAYMENT_GOTOBILLING_SORT_ORDER');
    }
  }
?>
