<?php
/*
  $Id: $

  osCommerce, Open Source E-Commerce Solutions
  http://www.oscommerce.com

  Copyright (c) 2007 osCommerce

  Released under the GNU General Public License
*/

  class gotobilling_cc {
    var $code, $title, $description, $enabled;

// class constructor
    function gotobilling_cc() {
      global $order;

      $this->code = 'gotobilling_cc';
      $this->title = MODULE_PAYMENT_GOTOBILLING_CC_TEXT_TITLE;
      $this->public_title = MODULE_PAYMENT_GOTOBILLING_CC_TEXT_PUBLIC_TITLE;
      $this->description = MODULE_PAYMENT_GOTOBILLING_CC_TEXT_DESCRIPTION;
      $this->sort_order = MODULE_PAYMENT_GOTOBILLING_CC_SORT_ORDER;
      $this->enabled = ((MODULE_PAYMENT_GOTOBILLING_CC_STATUS == 'True') ? true : false);

      if ((int)MODULE_PAYMENT_GOTOBILLING_CC_ORDER_STATUS_ID > 0) {
        $this->order_status = MODULE_PAYMENT_GOTOBILLING_CC_ORDER_STATUS_ID;
      }

      if (is_object($order)) $this->update_status();

      //$this->form_action_url = 'https://GOTOBILLING.de/merchant/' . MODULE_PAYMENT_GOTOBILLING_ID . '/processor.php';
	  
	  $this->form_action_url = 'https://secure.gotobilling.com/os/system/gateway/transact.php';
    }

	// class methods
    function update_status() {
      global $order;

      if ( ($this->enabled == true) && ((int)MODULE_PAYMENT_GOTOBILLING_CC_ZONE > 0) ) {
        $check_flag = false;
        $check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_GOTOBILLING_CC_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
        while ($check = tep_db_fetch_array($check_query)) {
          if ($check['zone_id'] < 1) {
            $check_flag = true;
            break;
          } elseif ($check['zone_id'] == $order->billing['zone_id']) {
            $check_flag = true;
            break;
          }
        }

        if ($check_flag == false) {
          $this->enabled = false;
        }
      }
    }

    function javascript_validation() {
      return false;
    }

    function selection() {
      global $order;

      for ($i=1; $i<13; $i++) {
        $expires_month[] = array('id' => sprintf('%02d', $i), 'text' => strftime('%B',mktime(0,0,0,$i,1,2000)));
      }

      $today = getdate(); 
      for ($i=$today['year']; $i < $today['year']+10; $i++) {
        $expires_year[] = array('id' => strftime('%y',mktime(0,0,0,1,1,$i)), 'text' => strftime('%Y',mktime(0,0,0,1,1,$i)));
      }
      $selection = array('id' => $this->code,
                         'module' => $this->title,
                         'fields' => array(array('title' => MODULE_PAYMENT_GOTOBILLING_TEXT_CREDIT_CARD_OWNER,
                                                 'field' => tep_draw_input_field('gotobilling_cc_owner', $order->billing['firstname'] . ' ' . $order->billing['lastname'])),
                                           array('title' => MODULE_PAYMENT_GOTOBILLING_TEXT_CREDIT_CARD_NUMBER,
                                                 'field' => tep_draw_input_field('gotobilling_cc_number')),
                                           array('title' => MODULE_PAYMENT_GOTOBILLING_TEXT_CREDIT_CARD_EXPIRES,
                                                 'field' => tep_draw_pull_down_menu('gotobilling_cc_expires_month', $expires_month) . '&nbsp;' . tep_draw_pull_down_menu('gotobilling_cc_expires_year', $expires_year)),
										   array('title' => MODULE_PAYMENT_GOTOBILLING_TEXT_CREDIT_CARD_CVV,
                                                 'field' => tep_draw_input_field('gotobilling_cc_cvv')),
										)
					);

      return $selection;
    }

    function pre_confirmation_check() {
       global $HTTP_POST_VARS;

      include(DIR_WS_CLASSES . 'cc_validation.php');

      $cc_validation = new cc_validation();
      $result = $cc_validation->validate($HTTP_POST_VARS['gotobilling_cc_number'], $HTTP_POST_VARS['gotobilling_cc_expires_month'], $HTTP_POST_VARS['gotobilling_cc_expires_year']);
      $error = '';
      switch ($result) {
        case -1:
          $error = sprintf(TEXT_CCVAL_ERROR_UNKNOWN_CARD, substr($cc_validation->cc_number, 0, 4));
          break;
        case -2:
        case -3:
        case -4:
          $error = TEXT_CCVAL_ERROR_INVALID_DATE;
          break;
        case false:
          $error = TEXT_CCVAL_ERROR_INVALID_NUMBER;
          break;
      }

      if ( ($result == false) || ($result < 1) ) {
        $payment_error_return = 'payment_error=' . $this->code . '&error=' . urlencode($error) . '&gotobilling_cc_owner=' . urlencode($HTTP_POST_VARS['gotobilling_cc_owner']) . '&gotobilling_cc_expires_month=' . $HTTP_POST_VARS['gotobilling_cc_expires_month'] . '&gotobilling_cc_expires_year=' . $HTTP_POST_VARS['gotobilling_cc_expires_year'];

        tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, $payment_error_return, 'SSL', true, false));
      }

      $this->cc_card_type = $cc_validation->cc_type;
      $this->cc_card_number = $cc_validation->cc_number;
      $this->cc_expiry_month = $cc_validation->cc_expiry_month;
      $this->cc_expiry_year = $cc_validation->cc_expiry_year;
	  $this->cc_cvv = $HTTP_POST_VARS['gotobilling_cc_cvv'];
   
    }

    function confirmation() {
      global $HTTP_POST_VARS;

      $confirmation = array('title' => $this->title . ': ' . $this->cc_card_type,
                            'fields' => array(array('title' => MODULE_PAYMENT_GOTOBILLING_TEXT_CREDIT_CARD_OWNER,
                                                    'field' => $HTTP_POST_VARS['gotobilling_cc_owner']),
                                              array('title' => MODULE_PAYMENT_GOTOBILLING_TEXT_CREDIT_CARD_NUMBER,
                                                    'field' => substr($this->cc_card_number, 0, 4) . str_repeat('X', (strlen($this->cc_card_number) - 8)) . substr($this->cc_card_number, -4)),
                                              array('title' => MODULE_PAYMENT_GOTOBILLING_TEXT_CREDIT_CARD_EXPIRES,
                                                    'field' => strftime('%B, %Y', mktime(0,0,0,$HTTP_POST_VARS['gotobilling_cc_expires_month'], 1, '20' . $HTTP_POST_VARS['gotobilling_cc_expires_year'])))));

      return $confirmation;
    }

    function process_button() {
      global $order, $currencies, $currency;

      $zone_code = '';

      if (is_numeric($order->billing['zone_id']) && ($order->billing['zone_id'] > 0)) {
        $zone_query = tep_db_query("select zone_code from " . TABLE_ZONES . " where zone_id = '" . (int)$order->billing['zone_id'] . "'");
        if (tep_db_num_rows($zone_query)) {
          $zone = tep_db_fetch_array($zone_query);

          $zone_code = $zone['zone_code'];
        }
      }

      $process_button_string = tep_draw_hidden_field('merchant_id', MODULE_PAYMENT_GOTOBILLING_CC_MID) .
                               tep_draw_hidden_field('merchant_pin', MODULE_PAYMENT_GOTOBILLING_CC_PIN) .
                               tep_draw_hidden_field('x_debug', MODULE_PAYMENT_GOTOBILLING_CC_DEBUG_MODE) .
							   tep_draw_hidden_field('x_invoice_id', rand(1,999999999)) .
							   tep_draw_hidden_field('ip_address', tep_get_ip_address()) .
                               tep_draw_hidden_field('x_amount', number_format($order->info['total'] * 100, 0, '','')) .
                               tep_draw_hidden_field('x_transaction_type', 'ES') .
                               tep_draw_hidden_field('x_customer_id', $order->customer['lastname'].'-'.substr($this->cc_card_number,-4)) .
							   tep_draw_hidden_field('x_company', $order->customer['company']) .
							   tep_draw_hidden_field('x_first_name', $order->customer['firstname']) .
							   tep_draw_hidden_field('x_last_name', $order->customer['lastname']) .
							   tep_draw_hidden_field('x_email', $order->customer['email_address']) .
                               tep_draw_hidden_field('x_address1', $order->billing['street_address']) .
                               tep_draw_hidden_field('x_city', $order->billing['city']) .
                               tep_draw_hidden_field('x_zip', $order->billing['postcode']) .
                               tep_draw_hidden_field('x_state', $zone_code) .
                               //tep_draw_hidden_field('x_phone', $order->customer['telephone']) .
                               
							   tep_draw_hidden_field('x_cc_number', $this->cc_card_number) .
                               tep_draw_hidden_field('x_cc_exp', $this->cc_expiry_month . substr($this->cc_expiry_year, -2)) .
							   tep_draw_hidden_field('x_cc_cvv', $this->cc_cvv) .
							   
							   tep_draw_hidden_field('x_relay_url', tep_href_link(FILENAME_CHECKOUT_PROCESS, '', 'SSL', false)) .
                               tep_draw_hidden_field('x_relay_type', 'ACTIVE');
							   
      return $process_button_string;
    }

    function before_process() {
      global $HTTP_GET_VARS;
		
      if ($_GET['status'] == 'G' || $_GET['status'] == 'R') return;
      if ($_GET['status'] == 'D') {
        tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, 'error_message=' . urlencode(MODULE_PAYMENT_GOTOBILLING_CC_TEXT_DECLINED_MESSAGE), 'SSL', true, false));
      }
      // Code 3 is an error - but anything else is an error too (IMHO)
      tep_redirect(tep_href_link(FILENAME_CHECKOUT_PAYMENT, 'error_message=' . urlencode(MODULE_PAYMENT_GOTOBILLING_CC_TEXT_DECLINED_MESSAGE), 'SSL', true, false));
    }

    function after_process() {
      return false;
    }

    function get_error() {
      global $HTTP_GET_VARS;

      $error = array('title' => GOTOBILLING_CC_ERROR_HEADING,
                     'error' => ((isset($HTTP_GET_VARS['error'])) ? stripslashes(urldecode($HTTP_GET_VARS['error'])) : GOTOBILLING_CC_ERROR_MESSAGE));

      return $error;
    }

    function check() {
      if (!isset($this->_check)) {
        $check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_GOTOBILLING_CC_STATUS'");
        $this->_check = tep_db_num_rows($check_query);
      }
      return $this->_check;
    }

    function install() {
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Enable GOTOBILLING Module', 'MODULE_PAYMENT_GOTOBILLING_CC_STATUS', 'True', 'Do you want to accept GOTOBILLING payments?', '6', '1', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Merchant ID', 'MODULE_PAYMENT_GOTOBILLING_CC_MID', '', 'The merchant ID for the GOTOBILLING service', '6', '3', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Merchant PIN', 'MODULE_PAYMENT_GOTOBILLING_CC_PIN', '0', 'The merchant pin for the GOTOBILLING service', '6', '4', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Debug Mode', 'MODULE_PAYMENT_GOTOBILLING_CC_DEBUG_MODE', '1', '1 for Testing, 0 for Production', '6', '4', now())");
	  tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Sort order of display.', 'MODULE_PAYMENT_GOTOBILLING_CC_SORT_ORDER', '0', 'Sort order of display. Lowest is displayed first.', '6', '0', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Payment Zone', 'MODULE_PAYMENT_GOTOBILLING_CC_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.', '6', '2', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
      tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('Set Order Status', 'MODULE_PAYMENT_GOTOBILLING_CC_ORDER_STATUS_ID', '0', 'Set the status of orders made with this payment module to this value', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
    }

    function remove() {
      tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key in ('" . implode("', '", $this->keys()) . "')");
    }

    function keys() {
      return array('MODULE_PAYMENT_GOTOBILLING_CC_STATUS', 'MODULE_PAYMENT_GOTOBILLING_CC_MID', 'MODULE_PAYMENT_GOTOBILLING_CC_PIN', 'MODULE_PAYMENT_GOTOBILLING_CC_DEBUG_MODE', 'MODULE_PAYMENT_GOTOBILLING_CC_ZONE', 'MODULE_PAYMENT_GOTOBILLING_CC_ORDER_STATUS_ID', 'MODULE_PAYMENT_GOTOBILLING_CC_SORT_ORDER');
    }
  }
?>
